# Solidus Admin Bar

[![CircleCI](https://circleci.com/gh/QuintinAdam/solidus_admin_bar.svg?style=shield)](https://circleci.com/gh/QuintinAdam/solidus_admin_bar)
[![codecov](https://codecov.io/gh/QuintinAdam/solidus_admin_bar/branch/main/graph/badge.svg)](https://codecov.io/gh/QuintinAdam/solidus_admin_bar)

This extension adds an admin navbar to the frontend of your Solidus store. It allows for a quick link to the admin dashboard. 

The admin bar gets displayed at the top of each page to users logged in as an admin. It works with following the entities:
* Products
* Taxons/Taxonomies
* Pages  ([solidus_static_content](https://github.com/solidusio-contrib/solidus_static_content))
* Related Products  ([solidus_related_products](https://github.com/solidusio-contrib/solidus_related_products))

## Installation

Add solidus_admin_bar to your Gemfile:

```ruby
gem 'solidus_admin_bar'
```

Bundle your dependencies and run the installation generator:

```shell
bin/rails generate solidus_admin_bar:install
```

## Usage

You can edit the style of the admin navbar and you can edit the admin bar view.

## Development

### Testing the extension

First bundle your dependencies, then run `bin/rake`. `bin/rake` will default to building the dummy
app if it does not exist, then it will run specs. The dummy app can be regenerated by using
`bin/rake extension:test_app`.

```shell
bin/rake
```

To run [Rubocop](https://github.com/bbatsov/rubocop) static code analysis run

```shell
bundle exec rubocop
```

When testing your application's integration with this extension you may use its factories.
Simply add this require statement to your `spec/spec_helper.rb`:

```ruby
require 'solidus_admin_bar/testing_support/factories'
```

Or, if you are using `FactoryBot.definition_file_paths`, you can load Solidus core
factories along with this extension's factories using this statement:

```ruby
SolidusDevSupport::TestingSupport::Factories.load_for(SolidusAdminBar::Engine)
```

### Running the sandbox

To run this extension in a sandboxed Solidus application, you can run `bin/sandbox`. The path for
the sandbox app is `./sandbox` and `bin/rails` will forward any Rails commands to
`sandbox/bin/rails`.

Here's an example:

```
$ bin/rails server
=> Booting Puma
=> Rails 6.0.2.1 application starting in development
* Listening on tcp://127.0.0.1:3000
Use Ctrl-C to stop
```

### Updating the changelog

Before and after releases the changelog should be updated to reflect the up-to-date status of
the project:

```shell
bin/rake changelog
git add CHANGELOG.md
git commit -m "Update the changelog"
```

### Releasing new versions

Please refer to the dedicated [page](https://github.com/solidusio/solidus/wiki/How-to-release-extensions) on Solidus wiki.

## License

Copyright (c) 2021 [name of extension author], released under the New BSD License.
